/*<std-header orig-src='shore'>

 $Id: common_templates.cpp,v 3.0 2000/09/18 21:04:56 natassa Exp $

SHORE -- Scalable Heterogeneous Object REpository

Copyright (c) 1994-99 Computer Sciences Department, University of
                      Wisconsin -- Madison
All Rights Reserved.

Permission to use, copy, modify and distribute this software and its
documentation is hereby granted, provided that both the copyright
notice and this permission notice appear in all copies of the
software, derivative works or modified versions, and any portions
thereof, and that both notices appear in supporting documentation.

THE AUTHORS AND THE COMPUTER SCIENCES DEPARTMENT OF THE UNIVERSITY
OF WISCONSIN - MADISON ALLOW FREE USE OF THIS SOFTWARE IN ITS
"AS IS" CONDITION, AND THEY DISCLAIM ANY LIABILITY OF ANY KIND
FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.

This software was developed with support by the Advanced Research
Project Agency, ARPA order number 018 (formerly 8230), monitored by
the U.S. Army Research Laboratory under contract DAAB07-91-C-Q518.
Further funding for this work was provided by DARPA through
Rome Research Laboratory Contract No. F30602-97-2-0247.

*/

#include "w_defines.h"

/*  -- do not edit anything above this line --   </std-header>*/

#define SM_SOURCE
#define LOGREC_C
#ifdef __GNUG__
#   pragma implementation
#endif
#include "sm_int_2.h"

/*
 * Instantiations of templates that are used in MORE THAN ONE
 * file.  This is to reduce circularities in the physical dependence
 * graph.
 */

#ifdef EXPLICIT_TEMPLATE
/*
 * vol.cpp, sort.cpp rtree.cpp, btree_bl.cpp, btree_p.cpp
 */
template class w_auto_delete_array_t<char>; 

#include "auto_release.h"
/*
 * sm.cpp, sm_io.cpp, lid.cpp 
 */
template class auto_release_t<smutex_t>; 


/*
 * bf.cpp btree_impl.cpp, chkpt.cpp
 */
template class w_auto_delete_array_t<lpid_t>;

/*
 * restart.cpp, chkpt.cpp
 */
template class w_auto_delete_t<logrec_t>;

#endif

